#!/usr/bin/env wish

# Copyright (c) 2002-2008, Botik-Technologies, Ltd.
# See license.txt for more information.

#===============================================================================
#     
# Предоставляет
#     
#     proc   initHelp { }
#     proc   setTitleHW { tlong tshort }
#     global help
#     
# Использует
#     
#     global botikkey
#     

proc setTitleHW { tlong tshort } {
   global botikkey
   wm title .wHelp $tlong
   wm iconname .wHelp $tshort
   setWindowIcon .wHelp
   return [ ]
}

proc initHelp { } {
   global help
   global botikkey

   set help(windWidth) 550
   set help(bgTextWin) azure1
   set help(bgButWin)  gray84
   set help(bgButAct)  LightSteelBlue
   set help(textBtns)  0 ; # Кнопки текстовые или графические
   
   set help(titleLong)  "Справка по программе $botikkey(name)"
   set help(titleShort) "Help::$botikkey(name)"

   set help(currentHelp) -1
   set help(N)            0
   set help(I)           -1
   set help(URLs)         0

   set help(HelpIndex) \
[subst {
"Справка::Оглавление" "Help::$botikkey(name)::Index"
{Оглавление`H1`

o  `L1IT`O программе $botikkey(name)`HREF`HelpAbout` `L1N`
`N`
o  `L1IT`Как пользоваться справкой`HREF`HelpForHelp` `L1N`
`N`
o  `L1IT`Окно индикации состояния доступа к Сети`HREF`HelpForMainWindow` `L1N`
`N`
o  `L1IT`Окно настроек параметров программы $botikkey(name)`HREF`HelpForOptions` `L1N`
`N`
o  `L1IT`Окно журнала программы $botikkey(name)`HREF`HelpForLog` `L1N`
`N`
o  `L1IT`Про обновление программы $botikkey(name)`HREF`HelpDownload` `L1N`
}}]

   set help(HelpDownload) \
[subst {
"Про обновление программы $botikkey(name)" "Update::$botikkey(name)"
{Про обновление программы $botikkey(name)`H1`

Для обновления программы $botikkey(name) Вам надо посетить страничку\
`N`$botikkey(url_dload)`HREF`$botikkey(url_dload)`.`N`
`N`
См. также:`H2`
>  `L1IT`Список всех разделов справки...`HREF`HelpIndex` `L1N`
}}]


set help(HelpAbout) \
[subst {
"O программе $botikkey(name)" "About::$botikkey(name)"
{O программе $botikkey(name)`H1`

Программа `N`$botikkey(name)`B` написана в лаборатории "Ботик" как клиентская часть системы\
подтверждения права доступа Абонента к Сети. Успеху разработки\
способствовали Абоненты СТ "Ботик" -- и как бета-тестеры, и как\
разработчики.

Программа входит в пакет Botik Tools.

Официальный сайт программы: `N`$botikkey(url)`HREF`$botikkey(url)`.

Официальный сайт пакета: `N`$botikkey(url_tools)`HREF`$botikkey(url_tools)`.

Программа написана на языке `N`Tcl/Tk`B` и может быть легко перенесена на\
любые платформы. Есть версия программы на языке `N`Perl`B`.

`N`Ограничения на применение.`B` Программу можно использовать `N`только для\
постоянных высокоскоростных подключений`B`. Программу нельзя использовать\
для модемных подключений, которые (и без программы `N`$botikkey(name)`B`) в рамках\
протокола PPP имеют свой механизм подтверждения права пользования Сетью.

`N`Цель разработки:`B` сделать так, чтобы самозванцу было бы не просто\
выдать свой компьютер за компьютер добросовестного Абонента, не\
достаточно "подсмотреть" сетевые характеристики подключения, еще надо\
знать (украсть?) пароль доступа Абонента к Сети.

Начало разработки $botikkey(start_date), текущая версия ($botikkey(version))\
от $botikkey(ver_date).
`N`
Принципы работы`H2`
`N`
`N`С компьютера Абонента программа `N`$botikkey(name)`B`\
устанавливает связь с `N`Кей-сервером`B` (сервер проверки права доступа, `N`Key-server`B`)\
СТ \"$::net(name)\". Далее, используя `N`пароль (ключ) доступа`B` к Сети (известный только Абоненту),\
программа должна регулярно доказывать Кей-серверу, что этот компьютер принадлежит именно\
данному Абоненту. Вся система работает по принципам, общим для\
большинства систем распознавания \"свой-чужой\". 
`N`
Ключевые слова и термины:`H2`
`N`
o  `L1IT`Запрос (challenge)`L1B` -- Кей-сервер присылает\
программе $botikkey(name) запрос (\"загадку\"), на который от имени\
Абонента можно правильно ответить, если знаешь `L1N`пароль (ключ) доступа`L1B`\
данного Абонента к Сети.`L1N`
`N`
o  `L1IT`Ответ (response)`L1B` -- по полученному запросу (\"загадке\") и по\
полученному от Абонента `L1N`паролю доступа`L1B` программа $botikkey(name)\
строит ответ (\"разгадку\") и передает ее Кей-серверу; используются принципы\
"знаешь правильный пароль -- построишь правильный ответ, тем самым подтвердишь,\
что именно ты и есть тот самый Абонент".`L1N`
`N`
o  `L1IT`Признанные и отверженные.`L1B` Если на свой запрос Кей-сервер получает правильный\
ответ (то есть, ответ соответствует паролю Абонента), то Кей-сервер `L1N`признает`L1B`,\
что с ним общается именно "тот самый" Абонент. Иначе Кей-сервер `L1N`отвергает`L1B`\
попытку выдать себя за "того самого" Абонента.`L1N`
`N`
o  `L1IT`Пропуск в Сеть.`L1B` В случае признания Кей-сервером ответа,\
Абонент получает право пользования Сетью (конечно, при наличии\
неизрасходованной предоплаты на лицевом счету Абонента), в случае\
непризнания -- не получает такого права.`L1N`
`N`
o  `L1IT`Нейтральные информационные сообщения.`L1B`\
Кроме запросов (challenge) от Кей-сервера могут исходить и обычные\
информационные сообщения (например, о том, что средства на лицевом счету\
Абонента подходят к концу, или еще что-то). Эти информационные сообщения\
программой `L1N`$botikkey(name)`L1B` доставляются Абоненту для прочтения.`L1N`
`N`
o  `L1IT`Пароль и ключ доступа.`L1B`\
Пароль обычно придумывают такой, чтобы он был длинным, но легко\
запоминался пользователем. А для хранения на диске в файле удобнее\
хранить не пароль, а построенную по паролю некоторую строку символов --\
ключ. Программе `L1N`$botikkey(name)`L1B` достаточно либо задать пароль, либо\
предоставить файл с ключом доступа -- в обоих случаях она с одинаковым\
успехом будет строить ответы на запросы Кей-сервера. Подробнее см.\
раздел "Пароль доступа и ключ доступа" на сайте программы.\
Пароли (ключи) доступа Абоненты устанавливают (изменяют) самостоятельно\
на странице: `L1N`$botikkey(url_NadminAbPswd)`HREF`$botikkey(url_NadminAbPswd)`.`L1N`
`N`
o  `L1IT`Режим доступа (регион доступа) в запросе на доступ к Сети.`L1B`\
При помощи программы `L1N`$botikkey(name)`L1B` можно запросить у Кей-сервера различный\
режим (регион) доступа для своего компьютера: 

      `L1N`WORLD`L1B` -- "разреши для данного компьютера и внутренние (внутри\
СТ "$::net(name)"), и внешние обмены"; 

      `L1N`LOCAL`L1B` -- "разреши для данного компьютера только внутренние\
(внутри СТ "$::net(name)") обмены, запрети внешние обмены"; 

      `L1N`NONE`L1B` -- "запрети для данного компьютера все обмены: и\
внутренние (внутри СТ "$::net(name)"), и внешние".`L1N`
`N`
o  `L1IT`WORLD-ключ, LOCAL-ключ, NONE-ключ: режим доступа (регион\
доступа) у пароля (ключа) доступа.`L1B`\
Абонент может иметь несколько паролей (ключей) доступа; у каждого пароля\
(ключа) определяется свой предельный режим (регион) доступа: `L1N`WORLD`L1B`,\
`L1N`LOCAL`L1B` или `L1N`NONE`L1B`.

      `L1N`WORLD-ключ`L1B`: имея пароль (ключ) с предельным режимом WORLD,\
можно успешно запросить у Кей-сервера любой доступ (WORLD, LOCAL или\
NONE). 

      `L1N`LOCAL-ключ`L1B`: имея пароль (ключ) с предельным режимом LOCAL,\
можно успешно запросить у Кей-сервера только доступ LOCAL или NONE,\
доступ WORLD получить не удастся: если при помощи LOCAL-ключа будет\
запрошен доступ WORLD, то Кей-сервер предоставит доступ LOCAL.\ 

      `L1N`NONE-ключ`L1B`: имея пароль (ключ) с предельным режимом NONE, можно успешно\
запросить у Кей-сервера только доступ NONE, доступ WORLD или LOCAL\
получить не удастся: если при помощи LOCAL-ключа будет запрошен доступ\
WORLD или LOCAL, то Кей-сервер предоставит доступ NONE. 

      Иметь несколько паролей (ключей) доступа удобно. Пример использования:\
WORLD-ключ имеет только глава семьи (или учитель в школе) и никому его\
не отдает его. LOCAL-ключи даются остальным членам семьи (ученикам),\
после чего можно быть спокойным, что им доступны все городские сетевые\
ресурсы, не доступны внешние обмены и, поэтому, они не могут ввести\
семью (школу) в расход при помощи внешних обменов. А если владелец\
LOCAL-ключ провинился, то глава семьи может на время (до искупления\
вины) ограничить режим доступа у данного ключа уровнем NONE.`L1N`

`N`Дополнительный сервис: автоматический контроль за выходом в свет\
новых версий программа $botikkey(name)`H2`

При каждом запуске программа `N`$botikkey(name)`B` опрашивает некий\
HTTP-файл, в котором перечислены свежие версии компонентов в наборе\
Botik Tools. Если у пользователя установлена устаревшая версия, ему\
будет сообщено, что на сайте доступна новая версия.

`N`Как это выглядит`H2`

`N`$botikkey(name)`B` является оконным приложением со следующими видами\
окон: 

`N`Окно индикации состояния доступа к Сети`HREF`HelpForMainWindow` --\
очевидным образом (светофор: "красный, желтый, зеленый") здесь\
показано, получено ли признание у Кей-сервера, допущены ли мы в Сеть.\
Еще здесь можно задавать/менять запрашиваемый режим доступа к Сети\
(`N`WORLD`B`, `N`LOCAL`B` или `N`NONE`B`). 

`N`Окно журнала программы $botikkey(name)`HREF`HelpForLog` --\
позволяет просматривать журнал\ событий программы, сохранять его на\
диск, менять подробность журнала.

`N`Окно настроек параметров программы $botikkey(name)`HREF`HelpForOptions`\
-- позволяет определять различные параметры программы (в том числе --\
задавать/менять пароль доступа к Сети).

`N`Окно справки программы $botikkey(name)`HREF`HelpForHelp` -- позволяет\
просматривать встроенную справку по пользованию программой. 

Окно индикации состояния является основным окном программ\
$botikkey(name) -- при его закрытии программа завершается. В дополнение\
к нему одновременно может быть открыто любое сочетание из остальных\
трех окон.`N`
`N`
См. также:`H2`
>  `L1IT`Список всех разделов справки...`HREF`HelpIndex` `L1N`
}} ]

set help(HelpForHelp) \
[subst {
"Справка::Как пользоваться справкой" "Help::$botikkey(name)"
{Как пользоваться справкой`H1`

Рекомендуем следующий стиль работы со справой:
`N`
о  `L1IT`один раз откройте`L1B` окно со справкой;`L1N`
о  `L1IT`отрегулируйте удобное положение`L1B` окна со справкой;`L1N`
`N`
После этого в окне справки Вы будете видеть описание, соответствующее текущему окну.

В тексте справки, как и обычно, можно переходить по гиперссылкам.

`N`Кнопки в верхней рамке`H2`
`L1N`noNormal`IMGB` закрыть окно Справки.`L2N`
`L1N`helpNormal`IMGB` показать `L2N`список всех разделов справки`HREF`HelpIndex`.`L2N`
`L1N`prevNormal`IMGB` назад по истории просмотра (на предыдущую страницу Справки).`L2N`
`L1N`nextNormal`IMGB` вперед по истории просмотра.`L2N`
`N`
См. также:`H2`
>  `L1IT`Список всех разделов справки...`HREF`HelpIndex` `L1N`
}}]

set help(HelpForMainWindow) \
[subst {
"Справка::Окно индикации состояния доступа к Сети" "Help::$botikkey(name)"
{Окно индикации состояния доступа к Сети`H1`
`N`
Данное окно содержит изображение `N`светофора`B`, которое своим цветом\
показывает, удалось ли добиться признания у Кей-сервера или нет.\
Индикатор отображает и сам факт предоставления доступа, и подтвержденный\
Кей-сервером режим (регион) доступа:
`N`
о  `L1IT`Зеленый, LOCAL`L1B` -- разрешены локальные обмены, запрещены внешние обмены.
       `L1N`Признаки:`L1B` зеленый цвет и буква "L" на индикаторе, слово\
"LOCAL" на бордюре окна (в том числе на минимизированном окне на панели\
задач) и характерная иконка.`L1N`
`N`
о  `L1IT`Зеленый, WORLD`L1B` -- разрешены и локальные, и внешние обмены.
       `L1N`Признаки:`L1B` зеленый цвет индикатора, слово "WORLD" на\
бордюре окна (в том числе на минимизированном окне на панели задач) и\
характерная иконка.`L1N`
`N`
о  `L1IT`Красный, NONE`L1B` -- запрещены и локальные, и внешние обмены.
       `L1N`Признаки:`L1B` красный свет индикатора, слово "NONE" на\
бордюре окна (в том числе на минимизированном окне на панели задач) и\
характерная иконка.`L1N`
`N`
о  `L1IT`Желтый цвет индикатора`L1B`, как правило, соответствует\
переходным состояниям: что-то поменялось, а от Кей-сервера подтверждение\
права на доступ пока еще не поступило.`L1N`
`N`
В этом же окне расположена кнопка выбора запрашиваемого у Кей-сервера\
режима (региона) доступа (`N`WORLD`B`, `N`LOCAL`B` или `N`NONE`B`).

`N`Внимание:`B` после изменения запрашиваемого режима (региона) доступа\
должно пройти некоторое (иногда значительное -- около минуты) время до\
момента, когда Кей-сервер подтвердит изменение режима (региона) доступа\
и изменится состояние индикатора. Будьте терпеливыми.

`N`
Иконки окон программы $botikkey(name)`H2`

Цвет `N`светофора`B` очевидным образом дублируется на иконках всех окон\
программы:

`N`fig1`IMGB`

То есть, можно следить за признанием у Кей-сервера по иконкам окон\
(в том числе -- по иконкам минимизированных окон).
`N`
Сообщения о потере признания у Кей-сервера`H2`

В момент, когда цвет `N`светофора`B` меняется на красный (с любого другого),\
в журнал помещается сообщение о дате, времени и причине потери\
признания у Кей-сервера.

`N`Типичная причина`B` красного света у светофора: используется\
неправильный пароль, то есть пароль не соответствует сетевым настройкам\
компьютера.

`N`Рекомендации`B`:
`N`
о  `L1IT`Посмотрите `L1N`журнал программы`HREF`HelpForLog`, не был ли\
   изменен пароль в последнее время?`L1N`
о  `L1IT`В `L1N`окне настроек параметров`HREF`HelpForOptions`\
   установите правильный пароль доступа.`L1N`
о  `L1IT`Если это не исправило ситуацию, проверьте, не сбились ли\
   сетевые настройки компьютера.`L1N`
`N`
`N`Кнопки в правом столбце окна`H2`
`L1N`helpNormal`IMGB` показать Справку по текущему окну.`L2N`
`L1N`setupNormal`IMGB` открыть `L2N`окно настроек параметров программы`HREF`HelpForOptions`.`L2N`
`L1N`logNormal`IMGB` открыть `L2N`окно журнала программы`HREF`HelpForLog`.`L2N`
`N`
См. также:`H2`
>  `L1IT`Список всех разделов справки...`HREF`HelpIndex` `L1N`
}}]

set help(HelpForOptions) \
[subst {
"Справка::Окно настроек параметров программы $botikkey(name)" "Help::$botikkey(name)"
{Окно настроек параметров программы $botikkey(name)`H1`
`N`
Заведение паролей (ключей) доступа`H2`

Обратите внимание, пароли (ключи) доступа Абоненты устанавливают (изменяют)\
самостоятельно на странице: `N`$botikkey(url_NadminAbPswd)`HREF`$botikkey(url_NadminAbPswd)`.
`N`
Назначение окна`H2`

Данное окно позволяет определять различные параметры программы. В том\
числе это окно используется для ввода пароля (ключа) доступа.

Окно содержит:  левую панель, правую панель и нижний ряд кнопок.
`N`
Левая панель окна настройки параметров`H2`

Здесь можно задать следующие режимы:

В разделе `N`"При запуске программы"`B` можно установить, что при запуске\
программы окно индикации состояния доступа к Сети надо минимизировать.\
Главный индикатор тогда можно наблюдать на панели задач.

Напомним, что состояние главного индикатора влияет на вид всех иконок на\
бордюрах всех окон программы. Это позволяет следить за признанием у\
Кей-сервера, даже если окно минимизировано, как это показано на\
примерах:

Еще в разделе `N`"При запуске программы"`B` можно задать какой режим\
доступа (NONE, LOCAL, WORLD) надо запрашивать у Кей-сервера при\
запуске программы.

В разделе `N`"использовать иконки из семейства"`B` можно определить,\
какое семейство из четырех иконок будут соответствовать четырем\
состояниям основного индикатора, как это показано в таблице ниже:

`N`fig1`IMGB`

В разделе `N`"реакция на важные сообщения/события"`B` устанавливается,\
разрешено или запрещено принудительно предъявляться пользователю окно\
журнала, при возникновении важных сообщений/событий (в том числе, при\
получении информационного сообщения от Кей-сервера).

В разделе `N`"подробность журнала"`B` можно задать уровень подробности\
журнала (число от 0 до 3, где: 0 -- минимальная подробность, 3 --\
максимальная подробность).

В разделе `N`"Адрес Key-сервера"`B` можно вручную задать Адрес Key-сервера.\
Если данное поле пустое, то IP-адрес Кей-сервера определяется автоматически.

`N`
Правая панель окна настройки параметров`H2`

В разделе `N`"пароль"`B` можно либо ввести пароль с клавиатуры, либо считать\
`N`сохраненный ключ из`B` файла -- при помощи кнопки `N`readPswd`IMGB`.`N`

В разделе `N`"пароль в дальнейшем"`B` определяется, из какого источника\
при следующем запуске программа должна получать пароль (ключ) доступа.\
Возможны следующие варианты:

`N`
о  `L1IT`"пароль в дальнейшем буду вводить сам"`L1B` -- при следующем\
запуске Абоненту будет предъявлено окно настройки параметров и он,\
средствами раздела "пароль", либо введет пароль с клавиатуры, либо\
считает ключ из файла (`L1N`readPswd`IMGB`);`L1N`
`N`
о  `HREF`HelpEnv``L1IT`"пароль в дальнейшем задам в переменной среды"`L1B` --\
Абонент сам запишет ключ доступа (построенный по текущему паролю) в\
переменную BOTIKKEY среды окружения (environment), и при следующем запуске\
программы он будет оттуда считываться;`L1N`
`N`
о  `L1IT`"пароль в дальнейшем следует хранить в умолчательном файле"`L1B` --\
при сохранении (кнопка `L1N`yesAndWriteNormal`IMGB`) этой установки\
среди прочего на диске в умолчательный файл будет сохранен ключ\
(построенный по текущему паролю) и при следующем запуске программы он\
будет оттуда считываться;`L1N`
`N`
о  `L1IT`"пароль в дальнейшем следует хранить в указанном ниже файле"`L1B`.\
Абонент обязан (при помощи кнопки `L1N`fnameNormal`IMGB`) задать имя\
файла для сохранения ключа (построенного по паролю). При сохранении\
данного режима (кнопка `L1N`yesAndWriteNormal`IMGB`) в указанный файл на\
диске будет записан ключ (построенный по паролю) и при следующем запуске\
программы он будет оттуда считываться.`L1N`
`N`
`N`Смотрите`B` на сайте программы\
(`N`$botikkey(url)`HREF`$botikkey(url)`) разделы: "Ликбез по\
информационной безопасности" и "Различные способы хранения пароля: что\
выбрать?"`N`
`N`
Кнопки в нижнем правом углу окна`H2`
`L1N`helpNormal`IMGB` Показать окно справки программы $botikkey(name)\
(показать раздел, посвященный окну настройки параметров).`L2N`
`L1N`yesAndWriteNormal`IMGB` Применить и сохранить режимы -- apply and save:
          `L1N`(1)`L1B` начать использовать измененные режимы\
(и новый пароль/ключ, если он был изменен);
          `L1N`(2)`L1B` сохранить режимы в конфигурационном файле\
программы (для использования в следующем запуске программы);
          `L1N`(3)`L1B` сохранить ключ (построенный по паролю) в\
файле--если задано, что ключ надо сохранять в файле.`L1N`
`L1N`yesNormal`IMGB` Применить режимы -- apply -- начать использовать\
измененные режимы (и новый пароль/ключ, если он быль изменен).`L1N` 
`L1N`noNormal`IMGB` Закрыть окно настройки параметров программы\
$botikkey(name)`L1N`
`N`
См. также:`H2`
>  `L1IT`Список всех разделов справки...`HREF`HelpIndex` `L1N`
}}]

set help(HelpEnv) \
[subst {
"Справка::Задание переменной среды BOTIKKEY" "Help::$botikkey(name)"
{Задание переменной среды BOTIKKEY`H1`
`N`
Для задания переменной среды BOTIKKEY нужно\
в меню "Пуск-->Выполнить..." ("Start-->Run...") ввести команду\
`N`"setx BOTIKKEY Ваш_ключ_доступа"`B`. Построить ключ доступа по паролю\
можно с помощью утилиты Pswd2key, которая входит в состав пакета BotikTools.\
`N`
Для удаления переменной BOTIKKEY из среды окружения нужно ввести команду\
`N`"set BOTIKKEY"`B`.
`N`
См. также:`H2`
>  `L1IT`Список всех разделов справки...`HREF`HelpIndex` `L1N`
}}]


set help(HelpForLog) \
[subst {
"Справка::Окно журнала программы $botikkey(name)" "Help::$botikkey(name)"
{Окно журнала программы $botikkey(name)`H1`
`N`
Данное окно позволяет просмотреть журнал событий программы\
$botikkey(name), сохранять его на диск, менять подробность показа\
журнала.

В журнале событий отражаются события взаимодействия программы\
$botikkey(name) с Кей-сервером. Подробность показа журнала управляется\
уровнем подробности журнала (число от 0 до 3, где 0 -- минимальная\
подробность, 3 -- максимальная).

Цвет фона записей о событиях связан с цветом основного индикатора:
`N`
о  `L1IT`красный фон, полужирный шрифт`L1B` -- событие связано с потерей\
признания у Кей-сервера;`L1N`
о  `L1IT`желтый фон, полужирный шрифт`L1B` -- событие "переходного периода"\
(возможно, удастся установить/восстановить признание у Кей-сервера);`L1N`
о  `L1IT`зеленый фон, полужирный шрифт`L1B` -- событие связано с получением\
признания у Кей-сервера;`L1N`
о  `L1IT`голубой фон, полужирный шрифт`L1B` -- поступило информационное\
сообщение от Кей-сервера;`L1N`
о  `L1IT`бледно-салатовый фон, нормальный шрифт`L1B` -- нейтральные\
события в программе.`L1N`
`N`
Кнопки в верхнем ряду`H2`
`L1N`helpNormal`IMGB` Показать окно справки программы $botikkey(name)\
(показать раздел, посвященный окну журнала программы)`L2N`
`L1N`saveNormal`IMGB` Сохранить журнал в файле на диске`L2N`
`L1N`noNormal`IMGB` Закрыть окно журнала программы $botikkey(name)`L2N`
`L1N`refreshNormal`IMGB` Обновить окно журнала программы $botikkey(name) -- данная\
кнопка позволяет "перерисовать" окно журнала. Кнопку полезно\
использовать, например, после изменения уровня подробности показа\
журнала. Как раз рядом с кнопкой расположено поле управления уровнем\
подробности показа журнала (число от 0 до 3, где: 0 -- минимальная\
подробность, 3 -- максимальная).`L2N`
`N`
См. также:`H2`
>  `L1IT`Список всех разделов справки...`HREF`HelpIndex` `L1N`
}}]

return []

}
