#!/bin/sh\
exec wish "$0" "$@"

# Copyright (c) 2002-2008, Botik-Technologies, Ltd.
# See license.txt for more information.

# ================= Options =========================================================
#
# Предоставляет
#
#     readIniFile { }
#     runOptions { }
# 
#     vCMD { cmd }                     -- возвращает 1 и через паузу запускает $cmd
#     validateVerbose { }
#     validateMinimized { }            -- если надо, корректирует $botikkey(minimized) = 0,1
#     validateIconType { }             -- если надо, корректирует $botikkey(icontype)  = 0,1,2 (с учетом платформы)
#
# Пользует
#
#     global botikkey
#     global bkOptions
#     global bkLog
#     global tcl_platform

global bkOptions
set    bkOptions(width)      740 ; # ширина окна
set    bkOptions(height)     400 ; # высота окна
set    bkOptions(bg)     gray84 ; # background кнопок
set    bkOptions(bgo)    gray75 ; # background остального
set    bkOptions(relief)   ridge ; # relief двух подокон
set    bkOptions(clientStarted) 0; # отметка о запуске клиента, см. setVarsOptions и readIniFile

set    bkOptions(promt_use_removable_disk) 1 ;     # Один раз в сеанс дадим рекомендацию про съемный накопитель,
                                                   # см. chFileForPswdOptioms
set    bkOptions(pauseBeforPromptForPswd) 120000 ; # Раз в 2 мин.: Пароль доступа к СТ все еще не установлен..."
                                                   # См. readIniFile
                                               
global iface
if {[windowsPlatform]} {
        set iface(font1)  {Arial 10 bold}
        set iface(font2)  {Helvetica 10 bold}
        set iface(font3)  {Courier 10 bold}
        set iface(font4)  {Courier 10}
        set iface(font5)  {Helvetica 10}
        set iface(font6)  {Courier 2}
} else {
        set iface(font1)  {Courier 13 bold}
        set iface(font2)  {Courier 13 bold}
        set iface(font3)  {Courier 11 bold}
        set iface(font4)  {Courier 11}
        set iface(font5)  {Courier 13}
        set iface(font6)  {Courier 2}
}
                                               
# "Боевая" копия           Проверка/изменение          "Рабочая" копия (меняется в формчкe)
#
# botikkey(minimized)      validateMinimized[Optioms]  bkOptions(minimized)
# botikkey(icontype)       validateIconType[Optioms]   bkOptions(icontype)
# botikkey(showLog)        validateShowLogOptioms      bkOptions(showLog)
# botikkey(verbose)        validateVerbose[Optioms]    bkOptions(verbose)
#                                                      bkOptions(password)
# botikkey(d_password)     ---                         bkOptions(d_password)
# botikkey(save_pswd)      validateSavePswdOptioms     bkOptions(save_pswd)
# botikkey(user_pswd_file) chFileForPswdOptioms        bkOptions(user_pswd_file)


#                                     -- возвращает 1 и через паузу запускает $cmd

proc vCMD { cmd } {
   after 10 $cmd
   return 1
}

# -------------------------------------- проверка/правка "боевых" копий переменных
proc validateVerbose { } {
   global botikkey
   global bkLog
   if [string is integer -strict $botikkey(verbose) ] {
      set botikkey(verbose) [limits $botikkey(verbose) $bkLog(minV) $bkLog(maxV)]
   } else {
      set botikkey(verbose) $bkLog(maxV)
   }
   return $botikkey(verbose)
}

proc validateMinimized { } {
   global botikkey
   return [set botikkey(minimized) [limits $botikkey(minimized) 0 1] ]
}

proc validateRegionInit { } {
   global botikkey
   if { [lsearch -exact {NONE LOCAL WORLD} $botikkey(region_init) ] == -1} {
      set botikkey(region_init) NONE
   }
   return $botikkey(region_init)
}

proc validateIconType { } {
   global botikkey

   if {[windowsPlatform]} {
      set botikkey(icontype) [limits $botikkey(icontype) 1 2]
   } else {
      set botikkey(icontype) 0
   }
   return $botikkey(icontype)
}

# -------------------------------------- проверка/правка "рабочих" копий переменных
proc validateVerboseOptions { } {
   global bkOptions
   global bkLog
   if [string is integer -strict $bkOptions(verbose) ] {
      set bkOptions(verbose) [limits $bkOptions(verbose) $bkLog(minV) $bkLog(maxV)]
   } else {
      set bkOptions(verbose) $bkLog(maxV)
   }
   return 1
}

proc validateMinimizedOptions { } {
   global bkOptions
   set bkOptions(minimized) [limits $bkOptions(minimized) 0 1]
   return 1
}

proc validateShowLogOptions { } {
   global bkOptions
   set bkOptions(showLog) [limits $bkOptions(showLog) 0 1]
   return 1
}

proc validateIconTypeOptions { } {
   global bkOptions
   if {[windowsPlatform]} {
      set bkOptions(icontype) [limits $bkOptions(icontype) 1 2]
   } else {
      set bkOptions(icontype) 0
   }
   return 1
}

proc validateSavePswdOptions { } {
   global bkOptions
   if [string is integer -strict $bkOptions(save_pswd) ] {
      set bkOptions(save_pswd) [limits $bkOptions(save_pswd) 1 4]
   } else {
      set bkOptions(save_pswd) 1
   }
   return 1
}   

proc readPswd { } {
   global bkOptions
   set types {
       {{Text Files}       {.txt}        }
       {{All Files}        *             }
   }
   set readFileName "*.txt"

   if [winfo exists .wBkOptions] { set parent .wBkOptions } else { set parent . }
   set filename [tk_getOpenFile -filetypes $types -defaultextension .txt -parent $parent \
                                -title "Считать ключ доступа, сохраненный в файл?" \
                                -initialfile $readFileName ]
   if { ([string length $filename] == 0) || ([string first "*" $filename] >=0)} {
      return [];
   }

   readPswdFromFile $filename
   return [];
}

proc readPswdFromFile { fname } {
   global bkOptions
   # считываем пароль из файла fname

   set goon "retry"
   set d_password ""
   set done 0
   while { $goon eq "retry" } {
      set ok 0
      catch {
         # чтение пароля из файла $fname
         set out [open $fname r]
         set d_password [gets $out]
         close $out
         if { [string length $d_password] == 0 } {
            error "File \"$fname\" is empty"
         }
         set ok 1
      } rc
      if { !$ok } {
         if [winfo exists .wBkOptions] { set parent .wBkOptions } else { set parent . }
         set msg  "Не удалось считать ключ доступа из файла\n\"$fname\"\n\n[mkErrorCode $rc]"
         set goon [ tk_messageBox -icon warning -type retrycancel -parent $parent -default retry \
                        -title "Ошибка чтения ключа доступа" \
                        -message $msg]
         catch { close $out }
      } else {
         set done 1
         set goon cancel
      }
   }

   if { ! $done } {
      return []
   }

   set regexp_pswd {^[0-9a-f]*$}

   if { ([string length $d_password] != 32) || (! [regexp $regexp_pswd $d_password]) } {
      if [winfo exists .wBkOptions] { set parent .wBkOptions } else { set parent . }
      set msg "Неверно записан ключ доступа в файле\n\"$fname\"\n(ожидали 32 шестнадцатеричные цифры, а получили \"$d_password\")"
      set goon [ tk_messageBox -icon warning -type retrycancel  -parent $parent -default retry \
                     -title "Ошибка чтения ключа доступа" \
                     -message $msg ]
      showHelp HelpForOptions
      return []
   }
   set bkOptions(d_password) $d_password
   return []
}

proc chFileForPswdOptioms { } {
   global bkOptions

   if { $bkOptions(promt_use_removable_disk) } {
      message info "Настоятельно рекомендуем использовать\
                  \nсъемные диски (дискеты, Flash/USB-диски)\
                  \nдля хранения ключа доступа (см. Справку)"
      set bkOptions(promt_use_removable_disk) 0
   }

   set types {
       {{Text Files}       {.txt}        }
       {{All Files}        *             }
   }

   set writeFileName "*.txt"

   if [winfo exists .wBkOptions] { set parent .wBkOptions } else { set parent . }
   set filename [tk_getSaveFile -filetypes $types -defaultextension .txt -parent $parent \
                                -title "Сохранить ключ доступа в файле?" \
                                -initialfile $writeFileName ]
   if { ([string length $filename] == 0) || ([string first "*" $filename] >=0)} {
      set filename "**файл не указан**"
   } else {
      set bkOptions(save_pswd) 4
      set bkOptions(user_pswd_file) $filename
   }
   catch { .wBkOptions.rup.spswd.rest.t configure -text [leftDots 30 $bkOptions(user_pswd_file)] }
   return [];
}
# ================================================ Снятие/возврат копий
proc getVarsOptions { } {
   global botikkey
   global bkOptions
   set bkOptions(minimized)      $botikkey(minimized)     
   set bkOptions(icontype)       $botikkey(icontype)      
   set bkOptions(showLog)        $botikkey(showLog)       
   set bkOptions(verbose)        $botikkey(verbose)
   set bkOptions(region_init)    $botikkey(region_init)
   set bkOptions(password)       ""
   set bkOptions(d_password)     ""
   set bkOptions(save_pswd)      $botikkey(save_pswd)     
   set bkOptions(user_pswd_file) $botikkey(user_pswd_file)
   set bkOptions(addr)           $botikkey(addr)
   return [ ]
}

proc chkVarsOptions { } {
   global botikkey
   global bkOptions
   if { [string length $bkOptions(password)] > 0 } {
      set bkOptions(d_password)    [pswdToKey $bkOptions(password)]
   } elseif {[string length $bkOptions(d_password)] == 0} {
      set bkOptions(d_password)    $botikkey(d_password)
   }
   set bkOptions(same_icontype)  [expr {$bkOptions(icontype)   eq $botikkey(icontype)  }]
   set bkOptions(same_password)  [expr {$bkOptions(d_password) eq $botikkey(d_password)}]
   set bkOptions(empty_password) [expr {$bkOptions(d_password) eq $botikkey(md5_empty) }]
   set bkOptions(wrong_addr)     [expr {[string length $bkOptions(addr)] != 0 && !([chkIP $bkOptions(addr)] && [isLocal $bkOptions(addr) $bkOptions(addr)])}]
   set bkOptions(same_addr)      [expr {$bkOptions(addr) eq $botikkey(addr)}]
   return [ ]
}

proc setVarsOptions { } {
   global botikkey
   global bkOptions
   chkVarsOptions
   if {!$bkOptions(wrong_addr) && !$bkOptions(same_addr)} {
      set botikkey(addr) $bkOptions(addr)
      writeLogChangeStatus 0 GRAY "[strTime] Установлен (или сменен) адрес Key-сервера"
   }
   set botikkey(minimized)      $bkOptions(minimized)      
   set botikkey(icontype)       $bkOptions(icontype)       
   set botikkey(showLog)        $bkOptions(showLog)
   set botikkey(verbose)        $bkOptions(verbose)        
   set botikkey(save_pswd)      $bkOptions(save_pswd)      
   set botikkey(user_pswd_file) $bkOptions(user_pswd_file) 
   set botikkey(region_init)    $bkOptions(region_init)
   if { ! $bkOptions(same_icontype) } { resetIcons }
   if { (! $bkOptions(same_password) ) && (! $bkOptions(empty_password)) } {
      set botikkey(d_password)  $bkOptions(d_password)
      writeLogChangeStatus 0 GRAY "[strTime] Установлен (или сменен) пароль/ключ доступа"
      if { ! $bkOptions(clientStarted) } {
         set botikkey(region_by_user) [set botikkey(region_request) $botikkey(region_init)]
         set bkOptions(clientStarted) 1
         writeLogChangeStatus 0 GRAY "[strTime] Клиентская часть программы запущена"
         restartClient
      }
   }
   if {!$bkOptions(wrong_addr) && !$bkOptions(same_addr)} {
      writeLogChangeStatus 0 GRAY "[strTime] Клиентская часть программы перезапущена"
      restartClient
   }
   return [ ]
}

proc runOptions { } {
   createOptionsWindow
   popUpOptionsWindow
}

proc popUpOptionsWindow { } {
   catch { wm deiconify .wBkOptions; raise .wBkOptions; focus -force .wBkOptions.rup.pswd.e; }
   update
   return []
}

proc createOptionsWindow { } {
   global botikkey
   global bkOptions
   global myImages
   global bkLog
   global tcl_platform
   global iface
   if { [winfo exists .wBkOptions] } {
      return []
   }

   getVarsOptions
   toplevel .wBkOptions -width $bkOptions(width) -height $bkOptions(height)
   #catch "wm iconbitmap .wBkOptions $botikkey(currentIcon)"
   wm title .wBkOptions "Настройка программы $botikkey(version)"
   wm iconname .wBkOptions "Options::$botikkey(version)"
   setWindowIcon .wBkOptions

# Внешний вид и поведение программы ===================================================================

   frame .wBkOptions.left -width $bkOptions(width) -bd 3 -relief $bkOptions(relief)
   pack  .wBkOptions.left -side left -fill both -padx 3 -pady 3 ; # -anchor e 

# Вид при запуске
#
#    [ ] при запуске окно минимизировать               0/1 bkOptions(minimized)

   validateMinimizedOptions
   labelframe .wBkOptions.left.start -text "При запуске программы" -font $iface(font2) -bd 2
   pack  .wBkOptions.left.start -padx 4 -pady 4 -side top -fill x -anchor w
   checkbutton .wBkOptions.left.start.as_icon -text "окно минимизировать" \
         -font $iface(font5)  -anchor w -variable bkOptions(minimized)
   pack  .wBkOptions.left.start.as_icon -side top -anchor w -pady 0 -padx 2
   frame .wBkOptions.left.start.reg
   pack  .wBkOptions.left.start.reg -side top -anchor w -pady 0 -padx 2
   label .wBkOptions.left.start.reg.t -text "запрашивать доступ: " -font $iface(font5)
   tk_optionMenu .wBkOptions.left.start.reg.m bkOptions(region_init) WORLD LOCAL NONE
   pack  .wBkOptions.left.start.reg.t .wBkOptions.left.start.reg.m -side left -anchor w -pady 0 -padx 0

# Использовать иконки из семейства:                    bkOptions(icontype) 
# 
#    ( ) Unix/Mac: двуцветные, стандартные             0
#    (*) Windows, мелкие детали у иконок               1
#    ( ) Windows, крупные детали у иконок              2

   validateIconTypeOptions
   labelframe .wBkOptions.left.icontype -text "Использовать иконки из семейства" -font $iface(font2)
   pack  .wBkOptions.left.icontype -padx 4 -pady 4 -side top -fill x -anchor w
   foreach {type txt val} {      unix_macintosh "Unix/Mac, двуцветные, стандартные" 0
                                 windows_1      "Windows, мелкие детали у иконок"   1
                                 windows_2      "Windows, крупные детали у иконок"  2
   } {   if { [string first $tcl_platform(platform) $type] < 0 } {set state disabled} {set state normal}
         radiobutton .wBkOptions.left.icontype.$type -text  $txt -value $val\
            -font $iface(font5)  -anchor w -relief flat -variable bkOptions(icontype) \
            -command {vCMD validateIconTypeOptions} -state $state
         pack  .wBkOptions.left.icontype.$type -side top -anchor w  -fill x -padx 2 -pady 0
   }

# Реакция на важные сообщения/события:
#    [x] форсировать показ окна с журналом           (0,1) bkOptions(showLog)

   validateShowLogOptions
   labelframe .wBkOptions.left.showLog -text "Реакция на важные сообщения/события" -font $iface(font2) -bd 2
   pack  .wBkOptions.left.showLog -padx 4 -pady 4 -side top -fill x -anchor w
   checkbutton .wBkOptions.left.showLog.cb -text "форсировать показ окна с журналом" \
         -font $iface(font5)  -anchor w -variable bkOptions(showLog)
   pack  .wBkOptions.left.showLog.cb -side left -anchor w -pady 0 -padx 2 
 
# Подробность журнала
# 
# [0..3] уровень подробности

   labelframe .wBkOptions.left.logLevel -text "Подробность показа журнала" \
                  -font $iface(font2) -bd 2
   pack    .wBkOptions.left.logLevel -padx 4 -pady 4 -side top -fill x -anchor w
   validateVerboseOptions
   spinbox .wBkOptions.left.logLevel.verbs -from $bkLog(minV) -to $bkLog(maxV) -increment 1 -width 2 \
           -textvariable bkOptions(verbose) -validate all -vcmd {vCMD validateVerboseOptions}
   label   .wBkOptions.left.logLevel.vlabl -text "уровень подробности" -font $iface(font5) -anchor w
   pack    .wBkOptions.left.logLevel.verbs .wBkOptions.left.logLevel.vlabl  -side left -pady 2 -padx 2  -anchor w

# IP-адрес Key-сервера

   labelframe .wBkOptions.left.addr -text "Адрес Key-сервера" -font $iface(font2) -bd 2
   pack    .wBkOptions.left.addr -padx 4 -pady 4 -side top -fill x -anchor w
   entry .wBkOptions.left.addr.e -width 35  -font $iface(font5)  -textvariable bkOptions(addr)
   pack  .wBkOptions.left.addr.e -side left -anchor sw -fill x -padx 2 -pady 2

# Работа с паролем ===================================================================

   frame .wBkOptions.rup -width $bkOptions(width) -bd 3 -relief $bkOptions(relief)
   pack  .wBkOptions.rup -side top -fill both -padx 3 -pady 3 -anchor ne

# Пароль
#  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

   labelframe .wBkOptions.rup.pswd -text "Пароль" -font $iface(font2) -bd 2
   pack  .wBkOptions.rup.pswd -padx 4 -pady 4 -side top -fill x -anchor w
   entry .wBkOptions.rup.pswd.e -show "*" -width 35  -font $iface(font5)  -textvariable bkOptions(password)
   pack  .wBkOptions.rup.pswd.e -side left -anchor sw -fill x -padx 2 -pady 2
   focus -force .wBkOptions.rup.pswd.e

   setImgButtons .wBkOptions.rup.pswd 2 2 right se [subst { 
         read  $myImages(readPswd) readPswd
   } ]

# В дальнейшем пароль
# (*) буду вводить сам
# ( ) задам в переменной среды
# ( ) следует хранить в умолчательном файле
# ( ) следует хранить в указанном ниже файле:
#              "**файл не указан**" [кнопка]

   labelframe .wBkOptions.rup.spswd -text "Пароль в дальнейшем" -font $iface(font2) -bd 2
   pack .wBkOptions.rup.spswd -padx 4 -pady 4 -side top -fill x -anchor w

   foreach {type txt val} {      o1 "буду вводить сам"                        1
                                 o2 "задам в переменной среды"                2
                                 o3 "следует хранить в умолчательном файле"   3
                                 o4 "следует хранить в указанном ниже файле:" 4
   } {   radiobutton .wBkOptions.rup.spswd.$type -text  $txt -value $val \
            -font $iface(font5)  -anchor w -relief flat -variable bkOptions(save_pswd) \
            -command {vCMD validateSavePswdOptions}
         pack .wBkOptions.rup.spswd.$type -side top -anchor w  -fill x -padx 2 -pady 0
   }

#              "**файл не указан**" [кнопка]

   frame .wBkOptions.rup.spswd.rest
   pack  .wBkOptions.rup.spswd.rest -side top -anchor e -padx 0 -pady 0
   label .wBkOptions.rup.spswd.rest.t -text [leftDots 31 $bkOptions(user_pswd_file)] -font $iface(font2)
   setImgButtons .wBkOptions.rup.spswd.rest 2 2 right e [subst { 
         chfile  $myImages(fnameNormal) chFileForPswdOptioms 
   } ]
   pack  .wBkOptions.rup.spswd.rest.t -side right -anchor e  -padx 2 -pady 2

# Кнопочки ===================================================================
   frame .wBkOptions.rightdn -width $bkOptions(width)
   pack  .wBkOptions.rightdn -side bottom -padx 3 -pady 3 -anchor se

   setImgButtons .wBkOptions.rightdn 2 2 right e [subst { 
         no    $myImages(noNormal)          cancelOptions 
         apply $myImages(yesNormal)         applyOptions 
         yes   $myImages(yesAndWriteNormal) applyAndSaveOptions 
         help  $myImages(helpNormal)        {showHelp HelpForOptions}
   } ]

   changesInHelpWindow HelpForOptions
   return [ ]
}

proc cancelOptions { } {
   catch {
      destroy .wBkOptions
      .mw.right.bsetup configure -state normal
      update
   }
   return [] ;
}

proc applyOptions { } {
   global botikkey
   global bkOptions

   setVarsOptions
   message info "Заданные Вами опции вступили в силу, но не были сохранены для использования\
               \nпри последующих запусках программы $botikkey(version)"
   return [];
}

proc applyAndSaveOptions { } {
   global botikkey
   global bkOptions

   chkVarsOptions
   if { $bkOptions(empty_password) } {
      message error "Необходимо задать непустой пароль"
      return [ ]
   }

   if { ($bkOptions(save_pswd)==4) && ([string first "*" $bkOptions(user_pswd_file)] >=0) } {
      message error "Выбрано хранение ключа доступа в файле, но имя файла не задано\
                   \nили задано некорректно (\"*\" в имени файла).\n\
                   \nНеобходимо задать корректное имя файла"
      return [ ]
   }

   if {$bkOptions(wrong_addr)} {
      message error "Ошибка ввода IP-адреса Key-сервера"
      return [ ]
   }

   setVarsOptions

   # Формируем все содержание файла с опциями:
   set fname  $bkOptions(user_pswd_file)
   if { [string first "*" $fname] >=0 } {
      set fname1 ""
   } else {
      set fname1 $fname
   }
   set allOptions "BotikKey-options:$bkOptions(minimized):$bkOptions(region_init):$bkOptions(icontype):$bkOptions(showLog):$bkOptions(verbose):$bkOptions(save_pswd):$fname1:$bkOptions(addr)"

   set step ""
   set ok 0
   catch {
      # сначала, запись пароля в файл $fname (если запрошено).
      if {$bkOptions(save_pswd) > 2} {
         # В какой файл писать пароль?
         if { $bkOptions(save_pswd) == 3 } {
            set fname $botikkey(dflt_pswd_file) 
         } else {
            set fname  $bkOptions(user_pswd_file)
         }
         set step "запись ключа доступа в файл\n\"$fname\""
         set goon "retry"
         set ok_w 0
         while { $goon eq "retry" } {
            set ok_w 0
            catch {
               # запись пароля в файл $fname
                set out [open $fname w]
               puts $out $bkOptions(d_password)
               close $out
               set ok_w 1
            } rc
            if { !$ok_w } {
               catch { close $out }
               set msg "Не удалось записать ключ доступа в файл\n\"$fname\"\n\n[mkErrorCode $rc]"
               set goon [ tk_messageBox -icon warning -type retrycancel -default retry \
                              -title "Ошибка записи ключа доступа" \
                              -message $msg ]
               #asksendmail $msg
            } else {
               set goon cancel
            }
         }
         if { !$ok_w } { error "Password has not been written to file \"$fname\"" }
      }
      # а теперь запись опций в файл
      set fname $botikkey(init_file)
      set step "запись опций в файл \"$fname\""
        set out [open $fname w]
      puts $out $allOptions
      close $out
      set ok 1
   } rc

   if { !$ok } {
      catch { close $out }
      set msg "Заданные Вами опции вступили в силу.  Однако их не удалось\
                   \nсохранить на диск для использования при последующих запусках\
                   \nпрограммы $botikkey(version).\n\
                   \nОшибки при сохранении опций, $step:\n[mkErrorCode $rc]\n\
                   \nМожете попробовать повторить операцию."
      message error $msg
      asksendmail $msg
      return [ ]
   }

   # предупреждение пользователя о хранении пароля
   set list {
         "01234"

         "В следующих запусках программы будет запрашиваться ввод пароля с клавиатуры."

         "В следующих запусках программы ключ доступа будет браться из переменной\
        \n\"BOTIKKEY\" среды.  Вам необходимо установить ключ доступа (посчитанный от\
        \nактуального пароля) в эту переменную среды."

         "В следующих запусках программы ключ доступа будет браться из умолчательного\
        \nфайла на диске."

         "В следующих запусках программы ключ доступа будет браться из заданного Вами\
        \nфайла."
       }

   set s [lindex $list $bkOptions(save_pswd) ]

   catch {
      destroy .wBkOptions
      .mw.right.bsetup configure -state normal
      update
   }
   message info "Заданные Вами опции вступили силу и были сохранены для использования\
               \nпри последующих запусках программы $botikkey(version)\n\
               \n$s\n\
               \nПожалуйста, прочтите в справке, как при этом способе обеспечивать\
               \nинформационную безопасность (сохранность Вашего пароля и ключа\
               \nдоступа к системе телекоммуникаций \"$::net(name)\")."
   return [ ];
}

proc readIniFile { } { 
   global bkOptions

   # Читаем установки, если пароль считан не пустым, то будет запущен
   # клиент (см. setVarsOptions). Иначе цикл: ждем некоторое время и напоминаем о
   # необходимости установки пароля и т.д.
   dolog [getWhoAmIInfo]
   readIniFile
   # checkPasswordAndClient
   return [ ]
}

proc checkPasswordAndClient { } {
   global bkOptions

   if { $bkOptions(clientStarted) } {
      return [ ]
   }

   message info "Пароль или ключ доступа к СТ \"$::net(name)\" все еще не установлен.\n\
                \nСейчас будет открыто окно настроек. Введите в нем пароль доступа\
                \nк СТ \"$::net(name)\", установите желаемые настройки и сохраните их."

   if { ![winfo exists .wBkOptions] } {
      runOptions
   } else {
      popUpOptionsWindow
   }
   after $bkOptions(pauseBeforPromptForPswd) { checkPasswordAndClient }
   return [ ]
}

proc readIniFile { } {
   global botikkey
   global bkOptions
   global env

   getVarsOptions

   set fname $botikkey(init_file)
   set ok 0
   catch {
      set step "чтение опций из файла \"$fname\""
      set out [open $fname r]
      set allOptions [gets $out]
      close $out
      if { ! [regexp {^BotikKey-options:([01]):(NONE|LOCAL|WORLD):([0-2]):([01]):([0-3]):([1-4]):(.*):(.*)$} $allOptions skip bkOptions(minimized) bkOptions(region_init) bkOptions(icontype) bkOptions(showLog) bkOptions(verbose) bkOptions(save_pswd) fname1 bkOptions(addr)] 
      } {
         error "The file \"$fname\" has invalid content"
      }
      set ok 1
   } rc
   if { !$ok } {
      catch { close $out }
      set msg "Не удалось считать файл с настройками\n\"$fname\":\n[mkErrorCode $rc]\n\
                    \nВозможно, это первый запуск программы $botikkey(version) на данном\
                    \nкомпьютере.\n\
                    \nСейчас будет открыто окно настроек. Введите в нем пароль доступа\
                    \nк СТ \"$::net(name)\", установите желаемые настройки и сохраните их.\n\
                    \nЕсли Вы ранее не использовали программу $botikkey(version) -- ознакомьтесь\
                    \nсо справкой окна настроек.\n\
                    \nОбратите внимание, пароли (ключи) доступа Абоненты устанавливают (изменяют)\
                    \nсамостоятельно на странице: $botikkey(url_NadminAbPswd)"
      message info $msg
      #asksendmail $msg
      runOptions
      return [ ];
   }

   if { [string length $fname1 ] == 0 } {
      set fname "**файл не указан**"
   } else {
      set fname $fname1
   }

   set bkOptions(user_pswd_file) $fname

   # Все опции получены, кроме пароля...

   setVarsOptions
   if { $botikkey(minimized) } { catch {wm iconify . } }

   # Добываем пароль
   set bkOptions(password) ""
   set bkOptions(d_password) ""

   if { $bkOptions(save_pswd) == 2 } {
      set d_password ""
      catch {
         set d_password $env(BOTIKKEY)
         set regexp_pswd {^[0-9a-f]*$}
         if { ([string length $d_password] == 32) && ([regexp $regexp_pswd $d_password]) } {
            set bkOptions(d_password) $d_password
         }
      }
      if { [string length $bkOptions(d_password)] == 0 } {
         if [winfo exists .wBkOptions] { set parent .wBkOptions } else { set parent . }
         set msg "Не удалось считать ключ доступа из переменной среды \"BOTIKKEY\"\
                     \n(ожидали 32 шестнадцатеричные цифры, получили \"$d_password\")"
         tk_messageBox -icon warning -type ok -parent $parent\
            -title "Ошибка чтения ключа доступа из переменной среды" \
            -message $msg
         showHelp HelpEnv
      }
   }

   if { $bkOptions(save_pswd) > 2 } {
      # В каком файле пароль?
      if { $bkOptions(save_pswd) == 3 } {
         set fname $botikkey(dflt_pswd_file)
      } else {
         set fname $bkOptions(user_pswd_file)
      }

      # считываем пароль из файла fname
      readPswdFromFile $fname
   }
   # здесь все опции ОК, разве только пароль может быть пустой...

   if { ([string length $bkOptions(password)] == 0) && ([string length $bkOptions(d_password)] == 0) } {
      runOptions
   } else {
      setVarsOptions
   }
   return [ ];
}
